// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_FSlowTask
	{
	public:
		virtual ~ISCW_FSlowTask() = default;
		
		virtual shared_ptr<ISCW_FSlowTask> ToFSlowTaskPtr() = 0;
		virtual shared_ptr<const ISCW_FSlowTask> ToFSlowTaskPtr() const = 0;

		virtual void Initialize() = 0;

		virtual void Destroy() = 0;

		virtual void MakeDialog(bool bShowCancelButton = false, bool bAllowInPIE = false) = 0;

		virtual void EnterProgressFrame(float ExpectedWorkThisFrame = 1.f, const wstring& Text = L"") = 0;
	};

	using ISCW_FSlowTaskConstPtr = shared_ptr<const ISCW_FSlowTask>;
	using ISCW_FSlowTaskPtr = shared_ptr<ISCW_FSlowTask>;
} // namespace Sourcify